﻿using UnityEngine;
using System.Collections;

public class MainController : MonoBehaviour
{
	private CsoundUnity csound;

	private int currentBeat=0;
	public float tempo = 2.0f;
	public int layerInst;
	public int seqLength;
	public float duration;
	public int[] noteRowList = new int[8];
	public int noteOffset;
	public int[] posIntensity = new int[8];

	public int panValue;


	// Use this for initialization
	void Start () 
	{
		csound = GetComponent<CsoundUnity>();
		csound.setChannel("tempo", tempo);  
		csound.setChannel("seqLength", seqLength);
		csound.setChannel("inst",layerInst);
		csound.setChannel("duration",duration);
		csound.setChannel("noteOffset",noteOffset);

		for (int count=0; count < 8; ++count)
		{
		int note = noteRowList[count];
			csound.setChannel("noteRowList",note);
		}
	}

	
	// Update is called once per frame
	void Update () 
	{
		//adjust tempo on the fly with up and down keys
		if(Input.GetKeyDown("up"))
		{
			tempo++;
			csound.setChannel("tempo", tempo);
		}
		else if(Input.GetKeyDown("down"))
		{
			tempo--;
			csound.setChannel("tempo", tempo);
		}
		//adjust seq length on the fly with left and right
		if(Input.GetKeyDown("left"))
		{
			seqLength++;
			csound.setChannel("seqLength", seqLength);
		}
		else if(Input.GetKeyDown("right"))
		{
			seqLength--;
			csound.setChannel("seqLength", seqLength);
		}

		if(currentBeat == csound.getChannel("beat"))
		{
			ResizeCubesInRow(currentBeat);
			currentBeat = (currentBeat!=seqLength-1 ? currentBeat+1 : 0);				
		}
		if(Input.GetKeyUp("r"))
		{
			BroadcastMessage("Randomize");
		}
	}

	void ResizeCubesInRow(int index)
	{
		for( int i = 0 ; i < 8; i++)
		{
			string objectName = "Row"+i;
			if(transform.Find(objectName))
				transform.Find(objectName).GetComponent<RowController>().ResizeCube(index);
		}
	}

	public void EnableCubeToPlaySound(int row, int index, bool state)
	{	
		//Debug.Log("Cell Instrument is:"+instrument);	
		row = row +1;
		string channel = "rowCubeIndex"+row;
		csound.setChannel(channel, index);
		channel = "rowCubeNote"+row;
		csound.setChannel(channel,noteRowList[index]);
		channel = "rowCubeState"+row;
		csound.setChannel(channel, state == true ? 1 : 0);

		Debug.Log("Playing"+row+","+index+","+state);
	}
}
